function [p,z,nu]=inertia(a,tol);
[lhs,rhs]=argn();
if rhs==1 then tol =1e-8; end;

// function gives the inertia of a symmetric or hermetian matrix.
// p= no. positive eigen values
// z=no. zero eigen values
// nu= no. negative eigen values.
// Inertia = (p,z,nu)
  
[m,n]=size(a);
e=rand(1)*tol;
[p1,n1]=inr(a+e*eye(n,n));
[p2,n2]=inr(a-e*eye(n,n));
p=p2;z=abs(p1-p2);nu=n1;
endfunction

 

