// Function for checking sign definiteness of symmetric or hermetian matrices
//---------------------------------------------------------------------------
// Input Symmetric or Hermetian matrix X.
// output 0 X is indefinite
//	  +1 X is positive definite
//	  +2 X is semidefinite in the limits specified by 'tol'
//	  -1 X is negative definite
//	  -2 X is negative semidefinite
//---------------------------------------------------------------------------
 
function x=ispd(X,tol)
[lhs,rhs]=argn();

if rhs==1 then tol=1e-10; end;
[n,n]=size(X);

x=0;
[a,b,c]=inertia(X,tol);
if a==n then x=1;  return; end;
if c==n then x=-1; return; end;
if c==0 & b <> 0 then x=2; return; end;
if a==0 & b <> 0 then x=-2; return; end;
endfunction

