//Solution of lyapunov equations with complex coeffciients
// ***********************************************************
// 			AX+XA*=P
// A is complex. P Hermetian. Look for Hermetian solutions.
//************************************************************
//Rayleigh Ritz method, Solution in space of Hermetian matrices over reals
// of Dimension n^2.
// Select an orthonormal basis and implement the procedure.
// A1&A2 corespond to the basis vectors with real entries
//A3&A4 Correspond to vectors with complex entries.
// ---------------------------------------------------------------------------
function gc=lyap_c_1(a,p);
[m n]=size(a);
r2=sqrt(2);
sqr2=1/r2;
r=1;
x=1;
d=n*(n+1);
for i=1:n,
for j=i:n,
c=1;
v=spzeros(n,n);
//basis is 1 on diagonal, 1/root-2 symetrically placed on off-diagonal positions
if i==j then
		v(i,i)=1;
else
		v(i,j)=sqr2;
 		v(j,i)=v(i,j);
end;
l1v=v*a+a'*v;
///////////////////////////
for row=1:n,
for col=row:n,
	if clean(l1v(row,col))<>0 then
		if row==col then
		A(x)=real(l1v(row,col));
		else 
		A(x)= r2*real(l1v(row,col));
		end;
		ij(x,1)= r; 
		ij(x,2)=c; x=x+1;
		end;
c=c+1;
end;
end;
c=1;
for row=1:n-1
for col=row+1:n,
A2(r,c)=r2*imag(l1v(row,col));
c=c+1;
end;
end;
B(r)= trace(p*v);
r=r+1;
end;
end;
mn=[d/2,d/2];
A1=sparse(ij,A,mn);
B1=B;
r=1; 
A1=full(A1);
/////////////////////////////////////////////////////////////////
clear A;
clear B;
clear ij;
//////////////////////////////////////////////////////////////////////////
r2=sqrt(2);
sqr2=1/r2;
r=1;
x=1;
for i=1:n-1,
for j=i+1:n,
c=1;
v=spzeros(n,n);
		v(i,j)=%i*sqr2;
		v(j,i)=-v(i,j);
l1v=v*a+a'*v;
x=1;
for row=1:n,
for col=row:n,
if row==col then
A3(r,x)=real(l1v(row,col));
else,
A3(r,x)=r2*real(l1v(row,col));
end;
x=x+1;
end;
end;
///////////////////////////
c=1;
for row=1:n-1
for col=row+1:n
A4(r,c)=r2*imag(l1v(row,col));
c=c+1;
end;
end;
B(r)= trace(p*v);
r=r+1;
end;
end;
A=[A1 A2;A3 A4];
B=[B1;B];
gc1=zeros(n,n)
X=inv(A)*B;
k=1;
for i=1:n,
for j=i:n,
if i==j then
gc1(i,j)=X(k);
else,
gc1(i,j)=sqr2*X(k);
end;
gc1(j,i)=gc1(i,j);
k=k+1;
end;
end;
gc2=zeros(n,n);
for i=1:n-1,
for j=i+1:n,
gc2(i,j)= %i*sqr2*X(k);
gc2(j,i)=gc2(i,j)';
k=k+1;
end;
end;
gc=gc1+gc2;
endfunction




