//Simultaneous solution of Lyapnov equations for Nonsingular descriptor systems
//-------------------------------------------------------------------------------
// Controllability Gramian: APE'+ EPA'=-BB'
// Observability Gramian: solve A'QZ + Z'QA=-C'C, Gramian is Z'QZ.
//-------------------------------------------------------------------------------
// Dosenot involve inversion of Z.
// System neednot be stable, however inv(Z)*A should satisfy condition for
// unique solution 
//-------------------------------------------------------------------------------
function [gc,go]=lyap_des(z,a,b,c);
[n,n]=size(a);
q=-c'*c;
p=-b*b';
clear c;
temp=z;
///////////////////////////////////////////////////////////////////////////
//k holds row number of A
r2=sqrt(2);
sqr2=1/r2;
r=1;
x=1;
d=n*(n+1);

for i=1:n,
for j=i:n,
c=1;
v=spzeros(n,n);
if i==j then
		v(i,i)=1;

else
		v(i,j)=sqr2;
		v(j,i)=v(i,j);
end;

l1v=a'*v*z+z'*v*a;
///////////////////////////
for row=1:n,
for col=row:n,
	if clean(l1v(row,col))<>0 then
		if row==col then
		A(x)=l1v(row,col);
		else 
		A(x)= r2*l1v(row,col);
		end;
		ij(x,1)= r; 
		ij(x,2)=c; x=x+1;
		end;

c=c+1;

end;
end;
B(r)= trace(p*v);
B(r+d/2)=trace(q*v);
r=r+1;
end;
end;

mn=[d/2 d/2];
A=sparse(ij,A,[mn]); 
z=spzeros(d/2,d/2);
A=[z A;A' z];
X=lusolve(A,B);
k=1;
for i=1:n,
for j=i:n,
if i==j then
	go(i,i)=X(k);
	gc(i,i)=X(k+d/2);
else
go(i,j)=sqr2*X(k);
go(j,i)=go(i,j);
gc(i,j)=sqr2*X(k+d/2);
gc(j,i)=gc(i,j);
end;
k=k+1;
end;
end;
go=temp'*go*temp;
endfunction
 

